<html>
<head>
<title>OGRE: OgrePlaneBoundedVolume.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgrePlaneBoundedVolume.h</h1><a href="OgrePlaneBoundedVolume_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __PlaneBoundedVolume_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __PlaneBoundedVolume_H_</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Precompiler options</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreSphere_8h.html">OgreSphere.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreMath_8h.html">OgreMath.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgrePlane_8h.html">OgrePlane.h</a>"</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040 
<a name="l00043"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html">00043</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a>
<a name="l00044"></a>00044     {
<a name="l00045"></a>00045     <span class="keyword">public</span>:
<a name="l00046"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#dffb808d81baf5b8342fc8959e8123bf">00046</a>         <span class="keyword">typedef</span> std::vector&lt;Plane&gt; <a class="code" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">PlaneList</a>;
<a name="l00048"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#20b9a9b8d76a970c5f6cbac4cb438054">00048</a>         <a class="code" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">PlaneList</a> planes;
<a name="l00049"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#4d323aac2569fdb268dd6dda2801896e">00049</a>         <a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc" title="The &amp;quot;positive side&amp;quot; of the plane is the half space to which the plane normal...">Plane::Side</a> outside;
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#9f3907950c9fd279e01ac1d4a03d9871">00051</a>         <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a>() :outside(<a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>::NEGATIVE_SIDE) {}
<a name="l00053"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#1f07490e0ddb2809e1e2b71a89c23856">00053</a>         <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a>(<a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc" title="The &amp;quot;positive side&amp;quot; of the plane is the half space to which the plane normal...">Plane::Side</a> theOutside) 
<a name="l00054"></a>00054             : outside(theOutside) {}
<a name="l00055"></a>00055 
<a name="l00059"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#ee3ce7eff75f501f8d9a33faa9b64174">00059</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box)<span class="keyword"> const</span>
<a name="l00060"></a>00060 <span class="keyword">        </span>{
<a name="l00061"></a>00061             <span class="keywordflow">if</span> (box.<a class="code" href="classOgre_1_1AxisAlignedBox.html#beef4ea1111a90001287734529288749" title="Returns true if the box is null i.e.">isNull</a>()) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00062"></a>00062             <span class="keywordflow">if</span> (box.<a class="code" href="classOgre_1_1AxisAlignedBox.html#45665abec389ae0ecbea54a26956a633" title="Returns true if the box is infinite.">isInfinite</a>()) <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064             <span class="comment">// Get centre of the box</span>
<a name="l00065"></a>00065             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> centre = box.<a class="code" href="classOgre_1_1AxisAlignedBox.html#7407087b6542b79792d915c60c0b49f0" title="Gets the centre of the box.">getCenter</a>();
<a name="l00066"></a>00066             <span class="comment">// Get the half-size of the box</span>
<a name="l00067"></a>00067             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> halfSize = box.<a class="code" href="classOgre_1_1AxisAlignedBox.html#dd9cf7a160ec472c91bf0fedb25cfed1" title="Gets the half-size of the box.">getHalfSize</a>();
<a name="l00068"></a>00068             
<a name="l00069"></a>00069             PlaneList::const_iterator i, iend;
<a name="l00070"></a>00070             iend = planes.end();
<a name="l00071"></a>00071             <span class="keywordflow">for</span> (i = planes.begin(); i != iend; ++i)
<a name="l00072"></a>00072             {
<a name="l00073"></a>00073                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane = *i;
<a name="l00074"></a>00074 
<a name="l00075"></a>00075                 <a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc" title="The &amp;quot;positive side&amp;quot; of the plane is the half space to which the plane normal...">Plane::Side</a> side = plane.<a class="code" href="classOgre_1_1Plane.html#e0131ee8cf1c09587c5cc4541c3b6297">getSide</a>(centre, halfSize);
<a name="l00076"></a>00076                 <span class="keywordflow">if</span> (side == outside)
<a name="l00077"></a>00077                 {
<a name="l00078"></a>00078                     <span class="comment">// Found a splitting plane therefore return not intersecting</span>
<a name="l00079"></a>00079                     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00080"></a>00080                 }
<a name="l00081"></a>00081             }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083             <span class="comment">// couldn't find a splitting plane, assume intersecting</span>
<a name="l00084"></a>00084             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00085"></a>00085 
<a name="l00086"></a>00086         }
<a name="l00090"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#4b02564f2535f2bdf1ac38447582f61a">00090</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; sphere)<span class="keyword"> const</span>
<a name="l00091"></a>00091 <span class="keyword">        </span>{
<a name="l00092"></a>00092             PlaneList::const_iterator i, iend;
<a name="l00093"></a>00093             iend = planes.end();
<a name="l00094"></a>00094             <span class="keywordflow">for</span> (i = planes.begin(); i != iend; ++i)
<a name="l00095"></a>00095             {
<a name="l00096"></a>00096                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane = *i;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098                 <span class="comment">// Test which side of the plane the sphere is</span>
<a name="l00099"></a>00099                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> d = plane.<a class="code" href="classOgre_1_1Plane.html#9548b13f88e65d98ea08ba01c8f2fad1" title="This is a pseudodistance.">getDistance</a>(sphere.<a class="code" href="classOgre_1_1Sphere.html#b33e56a0df43b2dfe3b72b59757e6f69" title="Returns the center point of the sphere.">getCenter</a>());
<a name="l00100"></a>00100                 <span class="comment">// Negate d if planes point inwards</span>
<a name="l00101"></a>00101                 <span class="keywordflow">if</span> (outside == <a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bcaf227c36d02442779fd4600d00580f5e">Plane::NEGATIVE_SIDE</a>) d = -d;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103                 <span class="keywordflow">if</span> ( (d - sphere.<a class="code" href="classOgre_1_1Sphere.html#8c0a5dee80bf790cdc5bd2a68f73a4c7" title="Returns the radius of the sphere.">getRadius</a>()) &gt; 0)
<a name="l00104"></a>00104                     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00105"></a>00105             }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109         }
<a name="l00110"></a>00110 
<a name="l00115"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#e4528e95f68402ad6fea0ff6414dbeb7">00115</a>         <span class="keyword">inline</span> std::pair&lt;bool, Real&gt; intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, ie a line with an origin and direction.">Ray</a>&amp; ray)
<a name="l00116"></a>00116         {
<a name="l00117"></a>00117             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(ray, planes, outside == <a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bcc5f2b56ac439b77aad6dfc4031891be5">Plane::POSITIVE_SIDE</a>);
<a name="l00118"></a>00118         }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120     };
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="namespaceOgre.html#f6bda7879d1ac92561a02cbd1833e1b1">00122</a>     <span class="keyword">typedef</span> std::vector&lt;PlaneBoundedVolume&gt; <a class="code" href="namespaceOgre.html#f6bda7879d1ac92561a02cbd1833e1b1">PlaneBoundedVolumeList</a>;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="preprocessor">#endif</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
